ga3w20/src/main/java/com/ga3w20/beans/NewsFeedBean.java
package com.ga3w20.beans;

import com.ga3w20.controllers.NewsFeedJpaController;
import java.io.Serializable;
import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

/**
 * This Bean is to control the current News feed that is activated in the DB
 *
 * @author Michael Mishin 
 */
@Named
@RequestScoped
public class NewsFeedBean implements Serializable{
    private String currentActiveURL;
    
    private static final int NEWS_TO_SHOW = 10; // how many news to show from the given link
    
    @Inject
    private NewsFeedJpaController newsFeedJpaController;
    
    /**
     * Constructor that will get the first active url link for the news feed
     * 
     * @author Michael Mishin 1612993
     */
    @PostConstruct
    public void init()
    {
        currentActiveURL = newsFeedJpaController.findNewsFeedEntities().stream()
                .filter(newsFeed -> newsFeed.getIsActive())
                .findFirst()
                .get().getLink();
    }
    
    /**
     * This method will return the current active URL for the news feed.
     * 
     * @return The current active news URL string.
     * @author Michael Mishin 1612993
     */
    public String getCurrentActiveURL()
    {
        return currentActiveURL;
    }
    
    /**
     * This method will return the size for how many news to show from a given rss feed link
     * 
     * @return The size of the news feed
     * @author Michael Mishin 1612993
     */
    public int getHowManyNewsToShow()
    {
        return NEWS_TO_SHOW;
    }
}

ga3w20/src/main/java/com/ga3w20/transactions/DownloadsController.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ga3w20.transactions;

import com.ga3w20.controllers.FormatJpaController;
import com.ga3w20.entities.Format;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.enterprise.context.SessionScoped;
import javax.inject.Inject;
import javax.inject.Named;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class is essentially only used to give out the list of formats but 
 * if we ever wanted to have different downloads for different books/formats
 * then this class would be a lot more useful.
 * @author Franco G. Moro
 */
@Named(value="downloads")
@SessionScoped
public class DownloadsController implements Serializable {
    private final static Logger LOG=LoggerFactory.getLogger(DownloadsController.class);
    
    @Inject
    private FormatJpaController formatJpa;
    
    private List<String> formats;

    public List<String> getFormats() {
        if(formats==null){
            formats=new ArrayList<String>();
            List<Format> formatEntities=formatJpa.findFormatEntities();
            for(Format f:formatEntities){
                formats.add(f.getFormat());
            }
        }
        return formats;
    }

    public void setFormats(List<String> formats) {
        this.formats = formats;
    }

    public FormatJpaController getFormatJpa() {
        return formatJpa;
    }

    public void setFormatJpa(FormatJpaController formatJpa) {
        this.formatJpa = formatJpa;
    }
    
    
    

    
    
    
    
}

ga3w20/src/main/java/com/ga3w20/transactions/InvoiceController.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ga3w20.transactions;

import com.ga3w20.authentication.UserController;
import com.ga3w20.beans.MailBean;
import com.ga3w20.entities.Books;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.List;
import javax.enterprise.context.SessionScoped;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import jodd.mail.Email;
import jodd.mail.MailServer;
import jodd.mail.SendMailSession;
import jodd.mail.SmtpServer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author Franco G. Moro
 * This class contains the actions related to an invoice.
 */
@Named(value = "invoice")
@SessionScoped
public class InvoiceController implements Serializable{
    @Inject
    private MailBean mailBean;
    @Inject UserController userController;
    private final String emailSender;
    private final String smtpPassword;
    private final String smtpServerName;
    private String lastFourDigits;
    private String total;
    private String totalSavings;
    private String saleNumber;
    private List<Books> boughtBooks;
    private BigDecimal totalTax;
    private Boolean sendByEmail;
    private final static Logger LOG = LoggerFactory.getLogger(InvoiceController.class);
    
    /**
     * This controller is used to set the fields defined in web.xml
     */
    public InvoiceController(){
        FacesContext ctx = FacesContext.getCurrentInstance();
        
        emailSender = ctx.getExternalContext().getInitParameter("emailSender");
        smtpPassword = ctx.getExternalContext().getInitParameter("smtpPassword");
        smtpServerName = ctx.getExternalContext().getInitParameter("smtpServerName");
    }
    /**
     * This method checks if the user desires to receive the invoice by email.
     * Redirects to downloads page.
     * @return String
     */
    public String redirectToDownloads(){
        if(sendByEmail){
            sendEmail(createHTMLString(),com.ga3w20.util.Messages.getMessage("com.ga3w20.bundles.messages", "invoiceFrom",null).getSummary() ,
                    userController.getEmail());
        }
        return "downloads.xhtml?faces-redirect=true";
    }
    /**
     * This method is used to send an email through the google smtp server.
     */
    public void sendEmail(String html,String subject,String emailAdd) {
        mailBean.setHtmlTextMsg(html);
        mailBean.setSubject(subject)  ;
        mailBean.setSendTo(emailAdd);
        mailBean.setPlainTextMsg(" ");
        // Create am SMTP server object
        SmtpServer smtpServer = MailServer.create()
                .ssl(true)
                .host(smtpServerName)
                .auth(emailSender, smtpPassword)
                //.debugMode(true)
                .buildSmtpMailServer();

        // Using the fluent style of coding create a plain and html text message
        Email email = Email.create().from(emailSender)
                .to(mailBean.getSendTo())
                .subject(mailBean.getSubject())
                .textMessage(mailBean.getPlainTextMsg() + "\n\n" + LocalDateTime.now())
                .htmlMessage( mailBean.getHtmlTextMsg());

        // Like a file we open the session, send the message and close the
        // session. Session automatically closed by using try-with-resources
        try ( // A session is the object responsible for communicating with the server
                SendMailSession session = smtpServer.createSession()) {
            // Like a file we open the session, send the message and close the
            // session
            session.open();
            session.sendMail(email);
            LOG.info("Email sent");
        }
    }
    /**
     * This private method is used to build an html document representing the invoice.
     * This is so it can be sent as an email.
     * @return html
     */
    private String createHTMLString(){
        StringBuilder stringBuilder=new StringBuilder();
        stringBuilder.append("<html><META http-equiv=Content-Type "
                        + "content=\"text/html; charset=utf-8\">"
                        + "<body> ");
        stringBuilder.append("<table>");
        
        stringBuilder.append("<tr>");
        stringBuilder.append("<th>");
        stringBuilder.append(com.ga3w20.util.Messages.getMessage("com.ga3w20.bundles.messages", "saleNum",null).getSummary());
        stringBuilder.append("</th>");
        stringBuilder.append("<td>");
        stringBuilder.append(this.saleNumber);
        stringBuilder.append("</td>");
        stringBuilder.append("</tr>");
        
        stringBuilder.append("<tr>");
        stringBuilder.append("<th>");
        stringBuilder.append(com.ga3w20.util.Messages.getMessage("com.ga3w20.bundles.messages", "total",null).getSummary());
        stringBuilder.append("</th>");
        stringBuilder.append("<td>");
        stringBuilder.append(this.total+"$");
        stringBuilder.append("</td>");
        stringBuilder.append("</tr>");
        
        stringBuilder.append("<tr>");
        stringBuilder.append("<th>");
        stringBuilder.append(com.ga3w20.util.Messages.getMessage("com.ga3w20.bundles.messages", "totalSaving",null).getSummary());
        stringBuilder.append("</th>");
        stringBuilder.append("<td>");
        stringBuilder.append(this.totalSavings+"$");
        stringBuilder.append("</td>");
        stringBuilder.append("</tr>");
        
        stringBuilder.append("<tr>");
        stringBuilder.append("<th>");
        stringBuilder.append(com.ga3w20.util.Messages.getMessage("com.ga3w20.bundles.messages", "paidWith",null).getSummary());
        stringBuilder.append("</th>");
        stringBuilder.append("<td>");
        stringBuilder.append(this.lastFourDigits);
        stringBuilder.append("</td>");
        stringBuilder.append("</tr>");
        
        stringBuilder.append("</table>");
        stringBuilder.append("<br></br>");
        stringBuilder.append("<br></br>");
        stringBuilder.append("<table>");
        stringBuilder.append("<tr>");
        stringBuilder.append("<th>");
        stringBuilder.append(com.ga3w20.util.Messages.getMessage("com.ga3w20.bundles.messages", "titleEmail",null).getSummary());
        stringBuilder.append("</th>");
        stringBuilder.append("<th>");
        stringBuilder.append(com.ga3w20.util.Messages.getMessage("com.ga3w20.bundles.messages", "authorEmail",null).getSummary());
        stringBuilder.append("</th>");
        stringBuilder.append("</tr>");
        for(Books b:boughtBooks){
            stringBuilder.append("<tr>");
            stringBuilder.append("<td>");
            stringBuilder.append(b.getTitle());
            stringBuilder.append("</td>");
            stringBuilder.append("<td>");
            stringBuilder.append(b.getAuthorId().getName());
            stringBuilder.append("</td>");
            stringBuilder.append("</tr>");
        }
        stringBuilder.append("</table>");
        stringBuilder.append("</body");
        stringBuilder.append("</html>");
        return stringBuilder.toString();
    }

    public String getLastFourDigits() {
        return lastFourDigits;
    }

    public void setLastFourDigits(String lastFourDigits) {
        this.lastFourDigits = lastFourDigits;
    }

    public String getTotal() {
        return total;
    }

    public void setTotal(String total) {
        this.total = total;
    }

    public String getTotalSavings() {
        return totalSavings;
    }

    public void setTotalSavings(String totalSavings) {
        this.totalSavings = totalSavings;
    }

    public String getSaleNumber() {
        return saleNumber;
    }

    public void setSaleNumber(String saleNumber) {
        this.saleNumber = saleNumber;
    }

    public List<Books> getBoughtBooks() {
        return boughtBooks;
    }

    public void setBoughtBooks(List<Books> boughtBooks) {
        this.boughtBooks = boughtBooks;
    }

    public BigDecimal getTotalTax() {
        return totalTax;
    }

    public void setTotalTax(BigDecimal totalTax) {
        this.totalTax = totalTax;
    } 

    public MailBean getMailBean() {
        return mailBean;
    }

    public void setMailBean(MailBean mailBean) {
        this.mailBean = mailBean;
    }

    public UserController getUserController() {
        return userController;
    }

    public void setUserController(UserController userController) {
        this.userController = userController;
    }

    public Boolean getSendByEmail() {
        return sendByEmail;
    }

    public void setSendByEmail(Boolean sendByEmail) {
        this.sendByEmail = sendByEmail;
    }
    
    
    
}

ga3w20/src/main/webapp/WEB-INF/content/browsebygenre.xhtml
<ui:composition
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
    xmlns:h="http://xmlns.jcp.org/jsf/html"
    xmlns:p="http://primefaces.org/ui"
    xmlns:f="http://java.sun.com/jsf/core"
    xmlns:jsf="http://xmlns.jcp.org/jsf">
    <div class="sidenav">
    <!--Nothing to show here since we are browsing by genre-->
    </div>
    <p:dataTable id="browseTable" value="#{theBooks.bookList}" var="aBook" binding="#{table}"
                 rendered="#{not empty theBooks.bookList}" rows="5" paginator="true"
                 paginatorTemplate="{FirstPageLink} {PreviousPageLink} {NextPageLink} {LastPageLink}"
                 paginatorPosition="top">
        <p:column class="browsebook">
            <div class="containerBrowsePage">
                <div class="bookcover">
                    <h:graphicImage library="images" name="coverImages/#{aBook.imageUrl}" height="150" width="90" />
                </div>
                <div class="bookinfo">
                    <p>
                        <!--Lead to the book page when clicking on the title-->
                        <h:form>
                            <h:commandLink class="aBookTitle" action="#{theBooks.showSelectedBook(aBook,user.userId)}">#{aBook.title}</h:commandLink><br/>
                            <!--Show which number it is in the top 5 seller-->
                            <h:outputText class="bookSeller" value=" ##{table.rowIndex+1} #{msgs.sellerIn} #{theBooks.selectByGenre}" rendered="#{table.rowIndex+1 le 5}"/><br/>
                        </h:form>
                        <span class="bookauthor">#{msgs.by} #{aBook.authorId.name}</span><span class="seperator"> | </span><h:outputText styleClass="bookdate" value="#{aBook.dataPublication}" ><f:convertDateTime pattern="yyyy-MM-dd"/></h:outputText><br/>
                        <span class="bookprice" jsf:rendered="#{aBook.salePrice eq aBook.listPrice}">CDN$ <span class="price">#{aBook.listPrice}</span></span>
                        <span class="bookprice" jsf:rendered="#{aBook.salePrice ne aBook.listPrice}">CDN$ <span style="color:black;text-decoration:line-through;font-size:20px">#{aBook.listPrice}</span><span class="price"> #{aBook.salePrice}</span></span>
                    </p>
                    <!--Show the description of the book when clicking on the arrows-->
                    <p class="bookdescription" id="description#{table.rowIndex+1}">#{aBook.description}</p>
                </div>
                <div class="boxArrows" id="box#{table.rowIndex+1}" onclick="expand(this.id)">
                    <span></span>
                    <span></span>
                    <span></span>
                </div>
            </div>
        </p:column>
    </p:dataTable>
</ui:composition>

ga3w20/src/main/webapp/WEB-INF/content/browsepage.xhtml
<ui:composition
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
    xmlns:h="http://xmlns.jcp.org/jsf/html"
    xmlns:p="http://primefaces.org/ui"
    xmlns:f="http://java.sun.com/jsf/core"
    xmlns:jsf="http://xmlns.jcp.org/jsf">
    <div class="sidenav">
    <p id="bookgenres">#{msgs.genres}</p>
    <!--Have a filter for the genre of your search when clicking on one of the genre displayed-->
    <ui:repeat var="entry" value="#{theBooks.genreMap.entrySet().toArray()}" varStatus="status">
        <h:form>
            <h:commandLink action="#{theBooks.searchBooksWithGenre(entry.key)}">#{entry.key}<span id="numOfBooksInGenre"> (#{entry.value})</span></h:commandLink>
        </h:form>
    </ui:repeat>
    </div>
    <div id="centerErrorDiv"> 
        <!--Displaying the error when searching for a book-->
        <h:outputText value="#{msgs.noBookTitle} &#34;#{theBooks.searchTerm}&#34;" rendered="#{empty theBooks.bookList and theBooks.selectBy eq 'bookTitle'}"/>
        <h:outputText value="#{msgs.noAuthorName} &#34;#{theBooks.searchTerm}&#34;" rendered="#{empty theBooks.bookList and theBooks.selectBy eq 'authorName'}"/>
        <h:outputText value="#{msgs.noPublisher} &#34;#{theBooks.searchTerm}&#34;" rendered="#{empty theBooks.bookList and theBooks.selectBy eq 'publisher'}"/>
        <h:outputText value="#{msgs.noIsbn} &#34;#{theBooks.searchTerm}&#34;" rendered="#{empty theBooks.bookList and theBooks.selectBy eq 'isbn'}"/>
    </div>
    <p:dataTable id="browseTable" value="#{theBooks.bookList}" var="aBook" binding="#{table}" 
                 rendered="#{not empty theBooks.bookList}" rows="5" paginator="true"
                 paginatorTemplate="{FirstPageLink} {PreviousPageLink} {NextPageLink} {LastPageLink}"
                 paginatorPosition="top">
        <p:column class="browsebook">
            <div class="containerBrowsePage">
                <div class="bookcover">
                    <h:graphicImage library="images" name="coverImages/#{aBook.imageUrl}" height="150" width="90" />
                </div>
                <div class="bookinfo">
                    <p>
                        <!--Lead to the book page when clicking on the title-->
                        <h:form>
                            <h:commandLink class="aBookTitle" action="#{theBooks.showSelectedBook(aBook,user.userId)}">#{aBook.title}</h:commandLink><br/>
                        </h:form>
                        <span class="bookauthor">#{msgs.by} #{aBook.authorId.name}</span><span class="seperator"> | </span><h:outputText styleClass="bookdate" value="#{aBook.dataPublication}" ><f:convertDateTime pattern="yyyy-MM-dd"/></h:outputText><br/>
                        <span class="bookprice" jsf:rendered="#{aBook.salePrice eq aBook.listPrice}">CDN$ <span class="price">#{aBook.listPrice}</span></span>
                        <span class="bookprice" jsf:rendered="#{aBook.salePrice ne aBook.listPrice}">CDN$ <span id="crossListPrice">#{aBook.listPrice}</span><span class="price"> #{aBook.salePrice}</span></span>
                    </p>
                    <!--Show the description of the book when clicking on the arrows-->
                    <p class="bookdescription" id="description#{table.rowIndex+1}">#{aBook.description}</p>
                </div>
                <div class="boxArrows" id="box#{table.rowIndex+1}" onclick="expand(this.id)">
                    <span></span>
                    <span></span>
                    <span></span>
                </div>
            </div>
        </p:column>
    </p:dataTable>
</ui:composition>

ga3w20/src/main/webapp/WEB-INF/content/downloads.xhtml
<?xml version='1.0' encoding='UTF-8' ?> 
<ui:composition
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
    xmlns:h="http://xmlns.jcp.org/jsf/html"
    xmlns:p="http://primefaces.org/ui"
    xmlns:b="http://bootsfaces.net/ui"
    xmlns:f="http://xmlns.jcp.org/jsf/core">

    <b:container>
        <p:dataTable id="browseTable" value="#{user.ownedBooks}" var="aBook" binding="#{table}"
                     rendered="#{not empty user.ownedBooks}" rows="5" paginator="true"
                     paginatorTemplate="{FirstPageLink} {PreviousPageLink} {NextPageLink} {LastPageLink}"
                     paginatorPosition="top">
            <p:column class="browsebook">
                <div class="containerBrowsePage">
                    <div class="bookcover">
                        <h:graphicImage library="images" name="coverImages/#{aBook.imageUrl}" height="150" width="90" />
                    </div>
                    <div class="bookinfo">
                        <p>
                            <h:form>
                                <h:commandLink class="aBookTitle" action="#{theBooks.showSelectedBook(aBook,user.userId)}">#{aBook.title}</h:commandLink><br/>
                            </h:form>
                            <span class="bookauthor">#{msgs.by} #{aBook.authorId.name}</span><span class="seperator"> | </span><span class="bookdate">#{aBook.dataPublication}</span><br/>
                            <button class="btn btn-secondary btn-lg">
                                <a href="#{request.contextPath}/resources/pdf/aliceInWonderland.pdf" download="aliceInWonderland.pdf">#{msgs.download}</a>
                            </button>

                        </p>
                        <p class="bookdescription" id="description#{table.rowIndex+1}">#{aBook.description}</p>
                    </div>
                    <div class="boxArrows" id="box#{table.rowIndex+1}" onclick="expand(this.id)">
                        <span></span>
                        <span></span>
                        <span></span>
                    </div>
                </div>
            </p:column>
        </p:dataTable>

    </b:container>
</ui:composition>

ga3w20/src/main/webapp/WEB-INF/content/welcomepage.xhtml
<!-- This is a content page that will be included in the layout page -->
<ui:composition
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
    xmlns:h="http://xmlns.jcp.org/jsf/html"
    xmlns:p="http://primefaces.org/ui"
    xmlns:b="http://bootsfaces.net/ui"
    xmlns:jsf="http://xmlns.jcp.org/jsf"
    xmlns:a="http://xmlns.jcp.org/jsf/passthrough"
    xmlns:f="http://xmlns.jcp.org/jsf/core">

    <div class="overlayContainer">
        <h:graphicImage library="images" name="welcome-page-shape.png" class="img-responsive imageShape" />
        <div class="absoluteCenter">
            <h1 class="bigText glowingText">#{msgs.storeName}</h1>
            <p:outputLabel class="disableForMoblie">#{msgs.welcomePageQuote} -Tomie dePaola</p:outputLabel>
            <h:form id="browseBooksForm">
                <button id="brwoseBooksBtn" class="glow-on-hover" style="background: #000000" type="submit" value="submit" jsf:action="#{theBooks.searchAll()}">
                    <span class="flameText">#{msgs.browseBooks}</span>
                </button>
            </h:form>
        </div>
    </div>

    <hr/>

    <!-- News Highlights -->
    <div class="cardShadow orangeBackground infoSpacing">
        <div class="container-fluid">
            <h2 class="text-center">#{msgs.newsHighlights}</h2>
            <div id="newsScroll" class="textWhite col-sm-offset-1 col-sm-10">
                <p:feedReader value="#{newsFeedBean.currentActiveURL}" var="feed" size="#{newsFeedBean.howManyNewsToShow}">
                    <div class="cardShadow gradientLightGray text-center newsItem newsFeedData">
                        <p:separator />
                        <h3 class="glowingText">
                            #{feed.title}
                        </h3>
                        <br/>
                        <h:outputText value="#{feed.description.value}" escape="false" />
                        <br/>
                        <h:outputLink role="button" id="newsBtn" value="#{feed.link}" target="_blank" class="textBlack">
                            <button class="glow-on-hover" type="button">
                                <span class="flameText">#{msgs.viewDetails}</span>
                            </button>
                        </h:outputLink>
<!--                        <a href="#{feed.link}" role="button" target="_blank" class="textBlack">
                            <button class="glow-on-hover" type="button">
                                <span class="flameText">#{msgs.viewDetails}</span>
                            </button>
                        </a>-->
                        <p:separator />
                        <f:facet name="error">
                            #{msgs.noNews}
                        </f:facet>
                    </div>
                </p:feedReader>
            </div>
        </div>
    </div>

    <!-- new books / on sale -->
    <div class="infoSpacing">
        <div class="container-fluid">
            <div class="row">
                <!-- Recent Books -->
                <div class="col-md-offset-1 col-md-5 innerGrayGredient">
                    <h2 class="text-center flameText"><span class="glyphicon glyphicon-plus"></span> #{msgs.newBooksFrontDoor}</h2>
                    <hr/>
                    <div class="showcase showcaseNewBooks text-center">
                        <!--<h:graphicImage library="images" name="shelf.png" class="img-responsive imageShape" />-->
                        <ui:repeat value="#{frontDoorOffersBean.newBooks}" var="book">
                            <div>
                                <!--Name of book-->
                                <h:form>
                                    <h:commandLink class="aBookTitle" action="#{theBooks.showSelectedBook(book,user.userId)}">#{book.title}</h:commandLink><br/>
                                </h:form>
                                
                                <!--Image-->
                                <h:form>
                                    <h:commandLink action="#{theBooks.showSelectedBook(book,user.userId)}">
                                        <h:graphicImage library="images" name="coverImages/#{book.imageUrl}" height="200px" class="cardShadow booksOnShelf"/>
                                    </h:commandLink>
                                </h:form>
                            </div>
                        </ui:repeat>
                    </div>
                    <div class="shelf shelfNewBooks">
                        <ui:repeat value="#{frontDoorOffersBean.newBooks}" var="book">
                            <div class="bookSpacing">
                                <!--Image-->
                                <h:form>
                                    <h:commandLink action="#{theBooks.showSelectedBook(book,user.userId)}">
                                        <h:graphicImage library="images" name="coverImages/#{book.imageUrl}" class="cardShadow booksOnShelf"/>
                                    </h:commandLink>
                                </h:form>
                            </div>
                        </ui:repeat>
                    </div>
                </div>
                
                <!-- Books on Sale -->
                <div class="col-md-5 innerGrayGredient">
                    <h2 class="text-center flameText"><span class="glyphicon glyphicon-fire"></span> #{msgs.onSaleFrontDoor}</h2>
                    <hr/>
                    <div class="showcase showcaseBooksOnSale text-center">
                        <!--<h:graphicImage library="images" name="shelf.png" class="img-responsive imageShape" />-->
                        <ui:repeat value="#{frontDoorOffersBean.booksOnSale}" var="book">
                            <div>
                                <!--Name of book-->
                                <h:form>
                                    <h:commandLink class="aBookTitle" action="#{theBooks.showSelectedBook(book,user.userId)}">#{book.title}</h:commandLink><br/>
                                </h:form>
                                
                                <!--Image-->
                                <h:form>
                                    <h:commandLink action="#{theBooks.showSelectedBook(book,user.userId)}">
                                        <h:graphicImage library="images" name="coverImages/#{book.imageUrl}" height="200px" class="cardShadow booksOnShelf"/>
                                    </h:commandLink>
                                </h:form>
                            </div>
                        </ui:repeat>
                    </div>
                    <div class="shelf shelfBooksOnSale">
                        <ui:repeat value="#{frontDoorOffersBean.booksOnSale}" var="book">
                            <div class="bookSpacing">
                                <!--Image-->
                                <h:form>
                                    <h:commandLink action="#{theBooks.showSelectedBook(book,user.userId)}">
                                        <h:graphicImage library="images" name="coverImages/#{book.imageUrl}" class="cardShadow booksOnShelf"/>
                                    </h:commandLink>
                                </h:form>
                            </div>
                        </ui:repeat>
                    </div>
                </div>
            </div>
        </div>

    </div>

    <!-- Recommendation -->
    <h:panelGroup rendered="#{!preRenderViewBean.cookiesEnabled or resentPageCookie.oldCustomer}" layout="block">
        <div class="cardShadow orangeBackground infoSpacing">
            <div class="container-fluid">
                <h:panelGroup rendered="#{!preRenderViewBean.cookiesEnabled}">
                    <h2 class="text-center">#{msgs.PleaseEnableCookies}</h2>
                </h:panelGroup>
                <h:panelGroup rendered="#{preRenderViewBean.cookiesEnabled}" layout="block" class="col-sm-offset-1 col-sm-10">
                    <h2 class="text-center">#{msgs.frontPageRecommendation}</h2>
                    <div id="frontPageRecommendation">
                        <ui:repeat value="#{frontDoorOffersBean.recommendedBooks}" var="book">
                            <div class="cardShadow gradientLightGray text-center frontPageRecommendationItem">
                                <h:form>
                                    <h:commandLink class="aBookTitle" action="#{theBooks.showSelectedBook(book,user.userId)}">#{book.title}</h:commandLink><br/>
                                </h:form>
                                <h:form>
                                    <h:commandLink action="#{theBooks.showSelectedBook(book,user.userId)}">
                                        <h:graphicImage library="images" name="coverImages/#{book.imageUrl}" class="cardShadow"/>
                                    </h:commandLink>
                                </h:form>
                                <button class="collapsible">#{msgs.moreInfo}</button>
                                <div class="collapsibleInfo">
                                    <p class="collapsibleText">#{book.description}</p>
                                </div>
                            </div>
                        </ui:repeat>
                    </div>
                </h:panelGroup>
            </div>
        </div>
    </h:panelGroup>
    
    
    <!-- Advertisement -->
    <h:panelGroup rendered="#{advertisementBean.advertisementActive}" class="infoSpacing" layout="block">
        <div class="container-fluid">
            <div class="advertisementsSection">
                <div class="title text-center">
                    <h1 class="bigText" style="text-decoration: underline;">#{msgs.ourSponsor}</h1>
                </div>
                
                <div class="advertisement">
<!--                    <a href="#{advertisementBean.currentAdvertisementURL}" target="_blank">
                        <img class="responsiveImage" src="#{advertisementBean.currentAdvertisementImage}"/>
                    </a>-->
                    <h:outputLink value="#{advertisementBean.currentAdvertisementURL}" target="_blank">
                        <img class="responsiveImage" src="#{advertisementBean.currentAdvertisementImage}"/>
                    </h:outputLink>
                </div>
            </div>
        </div>
    </h:panelGroup>
    
</ui:composition>